--Klein, xtimes function (8 bits)

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY klein_xtimes IS
  PORT (
    x_in  : IN STD_LOGIC_VECTOR(0 to 7);
    x_out : OUT STD_LOGIC_VECTOR(0 to 7)
    );
END klein_xtimes;


ARCHITECTURE rtl OF klein_xtimes IS
BEGIN
  x_out(7) <= x_in(0);
  x_out(6) <= x_in(7) xor x_in(0);
  x_out(5) <= x_in(6);
  x_out(4) <= x_in(5) xor x_in(0);
  x_out(3) <= x_in(4) xor x_in(0);
  x_out(2) <= x_in(3);
  x_out(1) <= x_in(2);
  x_out(0) <= x_in(1);
END rtl;